参考链接:

askubuntu.com/questions/1113974/using-c17-with-clang-on-ubuntu-16-04

mirror.linux-ia64.org/gnu/gcc/releases/


在 Ubuntu 16.04 上使用 C++17 和 clang++

我一辈子都想不出如何让 C++17 在 Ubuntu 16.04 上运行。

这适用于 Ubuntu 18.04:

sudo apt-get update
sudo apt-get install clang-6.0
它将 C++17 标准库头文件安装在/usr/include/c++/7. 但是,当我在 Ubuntu 16.04 中运行相同的命令时,我会在 中获得 C++14 标头/usr/include/c++/5,并且 C++17 功能将无法编译。

我也尝试按照此安装clang-7,但这导致了以下错误: clang: /usr/lib/x86_64-linux-gnu/libstdc++.so.6: version 'GLIBCXX_3.4.22' not found (required by clang)

抱歉,如果这是一个愚蠢的问题;我对这些东西很陌生,可能缺少一些明显的东西。

16.04
C++


最高分(默认)

4

+50
我遵循了同一篇文章,但几乎没有变化:

ldconfig设置后执行LD_LIBRARY_PATH。
将网址中的“18.04”更改为“16.04”。
安装是:

apt install build-essential xz-utils curl
curl -SL http://releases.llvm.org/7.0.1/clang+llvm-7.0.1-x86_64-linux-gnu-ubuntu-16.04.tar.xz | tar -xJC .
cp -r clang+llvm-7.0.1-x86_64-linux-gnu-ubuntu-16.04/ /usr/local/clang-7.0.1
export LD_LIBRARY_PATH=/usr/local/clang-7.0.1/lib:$LD_LIBRARY_PATH
export PATH=/usr/local/clang-7.0.1/bin:$PATH
ldconfig
然后创建if_test.cpp:

#include <iostream>

int main() {
    // if block with init-statement:
    if(int a = 5; a < 8) {
        std::cout << "Local variable a is < 8\n";
    } else {
        std::cout << "Local variable a is >= 8\n";
    }
    return 0;
}
源代码按以下指令编译:

clang++ -std=c++17 -stdlib=libc++ -Wall -pedantic if_test.cpp -o if_test
执行目标文件将给出正确的输出:

# ./if_test
Local variable a is < 8